import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import static java.util.Collections.reverse;


public class Queue<I> {

	private List<I> front;
	private List<I> back;
	
	public Queue(List<I> front, List<I> back) {
		this.front = front;
		this.back = back;
	}
	
	public Queue() { 
		this(new LinkedList<I>(),new LinkedList<I>()); 
	}
	
	public List<I> getContent() {
		List<I> all = new ArrayList<I>(front);
		all.addAll(back);
		return all;
	}
	
	public boolean checkInvarient() {
		return !(front.isEmpty() && !back.isEmpty());
	}
	
	public void add(I x) {
		if (front.isEmpty())
			front.add(x);
		else
			back.add(x);
	}
	
	public void remove() {
		front.remove(0);
		if (front.isEmpty() && !back.isEmpty()) {
			List<I> empty = front;
			front = back;
			back = empty;
			reverse(front);
		}
	}
	
	public I getFront() {
		return front.get(0);
	}
	
	public boolean isEmpty() {
		return front.isEmpty();
	}
}
